package cn.com.tenlion.systembase.service.keyplacepatrol;

import cn.com.tenlion.systembase.pojo.bos.keyplacepatrol.KeyPlacePatrolBO;
import cn.com.tenlion.systembase.pojo.dtos.keyplace.KeyPlaceDTO;
import cn.com.tenlion.systembase.pojo.dtos.keyplacepatrol.KeyPlacePatrolDTO;
import cn.com.tenlion.systembase.pojo.pos.keyplacepatrol.KeyPlacePatrolPO;
import cn.com.tenlion.systembase.pojo.vos.keyplacepatrol.KeyPlacePatrolVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IKeyPlacePatrolService
 * @Description: 重点场所巡查表
 * @Author: CodeFactory
 * @Date: 2021-11-24 10:39:11
 * @Version: 3.0
 **/
public interface IKeyPlacePatrolService {

    /**
     * 新增重点场所巡查表
     *
     * @param keyPlacePatrolVO
     * @return
     */
    void save(KeyPlacePatrolVO keyPlacePatrolVO);

    /**
     * 新增重点场所巡查表
     *
     * @param token
     * @param keyPlacePatrolVO
     * @return
     */
    void save(String token, KeyPlacePatrolVO keyPlacePatrolVO);

    /**
     * 新增重点场所巡查表
     *
     * @param keyPlacePatrolVO
     * @return keyPlacePatrolId
     */
    String saveReturnId(KeyPlacePatrolVO keyPlacePatrolVO);

    /**
     * 新增重点场所巡查表
     *
     * @param token
     * @param keyPlacePatrolVO
     * @return keyPlacePatrolId
     */
    String saveReturnId(String token, KeyPlacePatrolVO keyPlacePatrolVO);

    /**
     * 删除重点场所巡查表
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids, String idsStr);


    /**
     * 删除重点场所巡查表
     *
     * @param token
     * @param ids id列表
     * @param idsStr id列表
     * @return
     */
    void remove(String token, List<String> ids, String idsStr);

    /**
     * 删除重点场所巡查表（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改重点场所巡查表
     *
     * @param keyPlacePatrolId
     * @param keyPlacePatrolVO
     * @return
     */
    void update(String keyPlacePatrolId, KeyPlacePatrolVO keyPlacePatrolVO);

    /**
     * 修改重点场所巡查表
     *
     * @param token
     * @param keyPlacePatrolId
     * @param keyPlacePatrolVO
     * @return
     */
    void update(String token, String keyPlacePatrolId, KeyPlacePatrolVO keyPlacePatrolVO);

    /**
     * 重点场所巡查表详情
     *
     * @param params 参数Map
     * @return
     */
    KeyPlacePatrolDTO get(Map<String, Object> params);

    /**
     * 重点场所巡查表详情
     *
     * @param keyPlacePatrolId
     * @return
     */
    KeyPlacePatrolDTO get(String keyPlacePatrolId);

    /**
     * 重点场所巡查表详情
     *
     * @param params 参数Map
     * @return
     */
    KeyPlacePatrolBO getBO(Map<String, Object> params);

    /**
     * 重点场所巡查表详情
     *
     * @param keyPlacePatrolId
     * @return
     */
    KeyPlacePatrolBO getBO(String keyPlacePatrolId);

    /**
     * 重点场所巡查表详情
     *
     * @param params 参数Map
     * @return
     */
    KeyPlacePatrolPO getPO(Map<String, Object> params);

    /**
     * 重点场所巡查表详情
     *
     * @param keyPlacePatrolId
     * @return
     */
    KeyPlacePatrolPO getPO(String keyPlacePatrolId);

    /**
     * 重点场所巡查表列表
     *
     * @param params
     * @return
     */
    List<KeyPlacePatrolDTO> list(Map<String, Object> params);

    /**
     * 重点场所巡查表列表
     *
     * @param params
     * @return
     */
    List<KeyPlacePatrolBO> listBO(Map<String, Object> params);

    /**
     * 重点场所巡查表列表
     *
     * @param params
     * @return
     */
    List<KeyPlacePatrolPO> listPO(Map<String, Object> params);

    /**
     * 重点场所巡查表分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<KeyPlacePatrolDTO>> listPage(ListPage page);

    /**
     * 重点场所巡查表统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    void saveKafka(String keyPlacePatrolId, KeyPlacePatrolVO keyPlacePatrolVO, String creatorName, KeyPlaceDTO keyPlaceDTO);

    void updateKafka(String keyPlacePatrolId, KeyPlacePatrolVO keyPlacePatrolVO, String creatorName, KeyPlaceDTO keyPlaceDTO);

    void deleteKafka(String keyPlacePatrolId);

    String getUserData(Map<String, Object> params, KeyPlacePatrolVO keyPlacePatrolVO);
}